• Русский
  • DCSMachineTemplate [infrastructure.cluster.x-k8s.io/v1beta1]

    Description
    DCSMachineTemplate is the Schema for the dcsmachinetemplates API.
    Type
    object

    Specification

    PropertyTypeDescription
    apiVersionstring

    APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

    kindstring

    Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

    metadataObjectMeta

    ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

    specobject

    DCSMachineTemplateSpec defines the desired state of DCSMachineTemplate.

    statusobject

    DCSMachineTemplateStatus defines the observed state of DCSMachineTemplate.

    .spec

    Description
    DCSMachineTemplateSpec defines the desired state of DCSMachineTemplate.
    Type
    object
    Required
    template
    PropertyTypeDescription
    templateobject

    .spec.template

    Type
    object
    Required
    spec
    PropertyTypeDescription
    metadataObjectMeta

    ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create. This is a copy of customizable fields from metav1.ObjectMeta.

    ObjectMeta is embedded in Machine.Spec, MachineDeployment.Template and MachineSet.Template, which are not top-level Kubernetes objects. Given that metav1.ObjectMeta has lots of special cases and read-only fields which end up in the generated CRD validation, having it as a subset simplifies the API and some issues that can impact user experience.

    During the upgrade to controller-tools@v2 for v1alpha2, we noticed a failure would occur running Cluster API test suite against the new CRDs, specifically spec.metadata.creationTimestamp in body must be of type string: "null". The investigation showed that controller-tools@v2 behaves differently than its previous version when handling types from metav1 package.

    In more details, we found that embedded (non-top level) types that embedded metav1.ObjectMeta had validation properties, including for creationTimestamp (metav1.Time). The metav1.Time type specifies a custom json marshaller that, when IsZero() is true, returns null which breaks validation because the field isn't marked as nullable.

    In future versions, controller-tools@v2 might allow overriding the type and validation for embedded types. When that happens, this hack should be revisited.

    specobject

    DCSMachineSpec defines the desired state of DCSMachine.

    .spec.template.spec

    Description
    DCSMachineSpec defines the desired state of DCSMachine.
    Type
    object
    Required
    ipHostPoolRefvmTemplateName
    PropertyTypeDescription
    ipHostPoolRefobject

    LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.

    locationobject
    providerIDstring
    resourceobject
    vmConfigobject
    vmTemplateNamestring
    vmUrnstring

    .spec.template.spec.ipHostPoolRef

    Description
    LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.
    Type
    object
    PropertyTypeDescription
    namestring

    Name of the referent. This field is effectively required, but due to backwards compatibility is allowed to be empty. Instances of this type with an empty value here are almost certainly wrong. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

    .spec.template.spec.location

    Type
    object
    Required
    type
    PropertyTypeDescription
    namestring
    typestring
    urnstring

    .spec.template.spec.resource

    Type
    object
    Required
    type
    PropertyTypeDescription
    namestring
    typestring
    urnstring

    .spec.template.spec.vmConfig

    Type
    object
    Required
    dcsMachineCpuSpecdcsMachineMemorySpec
    PropertyTypeDescription
    cdRomDatastoreClusterNamestring
    cdRomDatastoreNamestring
    dcsMachineCpuSpecobject
    dcsMachineDiskSpecarray
    dcsMachineMemorySpecobject
    dvSwitchNamestring
    portGroupNamestring
    portGroupUrnstring

    .spec.template.spec.vmConfig.dcsMachineCpuSpec

    Type
    object
    Required
    quantity
    PropertyTypeDescription
    quantityinteger

    .spec.template.spec.vmConfig.dcsMachineDiskSpec

    Type
    array

    .spec.template.spec.vmConfig.dcsMachineDiskSpec[]

    Type
    object
    Required
    quantity
    PropertyTypeDescription
    datastoreClusterNamestring
    datastoreNamestring
    datastoreUrnstring
    formatstring
    mountOptionsarray
    optionsarray
    pathstring
    quantityinteger
    systemVolumeboolean
    wipeFilesystemboolean

    .spec.template.spec.vmConfig.dcsMachineDiskSpec[].mountOptions

    Type
    array

    .spec.template.spec.vmConfig.dcsMachineDiskSpec[].mountOptions[]

    Type
    string

    .spec.template.spec.vmConfig.dcsMachineDiskSpec[].options

    Type
    array

    .spec.template.spec.vmConfig.dcsMachineDiskSpec[].options[]

    Type
    string

    .spec.template.spec.vmConfig.dcsMachineMemorySpec

    Type
    object
    Required
    quantity
    PropertyTypeDescription
    quantityinteger

    .status

    Description
    DCSMachineTemplateStatus defines the observed state of DCSMachineTemplate.
    Type
    object

    API Endpoints

    The following API endpoints are available:

    • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/dcsmachinetemplates
      • DELETE: delete collection of DCSMachineTemplate
      • GET: list objects of kind DCSMachineTemplate
      • POST: create a new DCSMachineTemplate
    • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/dcsmachinetemplates/{name}
      • DELETE: delete the specified DCSMachineTemplate
      • GET: read the specified DCSMachineTemplate
      • PATCH: partially update the specified DCSMachineTemplate
      • PUT: replace the specified DCSMachineTemplate
    • /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/dcsmachinetemplates/{name}/status
      • GET: read status of the specified DCSMachineTemplate
      • PATCH: partially update status of the specified DCSMachineTemplate
      • PUT: replace status of the specified DCSMachineTemplate

    /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/dcsmachinetemplates

    HTTP method
    DELETE
    Description
    delete collection of DCSMachineTemplate
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    list objects of kind DCSMachineTemplate
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplateList schema
    401 - UnauthorizedEmpty
    HTTP method
    POST
    Description
    create a new DCSMachineTemplate
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyDCSMachineTemplate schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplate schema
    201 - CreatedDCSMachineTemplate schema
    202 - AcceptedDCSMachineTemplate schema
    401 - UnauthorizedEmpty

    /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/dcsmachinetemplates/{name}

    HTTP method
    DELETE
    Description
    delete the specified DCSMachineTemplate
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    202 - AcceptedStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    read the specified DCSMachineTemplate
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplate schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update the specified DCSMachineTemplate
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplate schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace the specified DCSMachineTemplate
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyDCSMachineTemplate schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplate schema
    201 - CreatedDCSMachineTemplate schema
    401 - UnauthorizedEmpty

    /apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/dcsmachinetemplates/{name}/status

    HTTP method
    GET
    Description
    read status of the specified DCSMachineTemplate
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplate schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update status of the specified DCSMachineTemplate
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplate schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace status of the specified DCSMachineTemplate
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyDCSMachineTemplate schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKDCSMachineTemplate schema
    201 - CreatedDCSMachineTemplate schema
    401 - UnauthorizedEmpty